#ifndef H_LDAPPLUGIN
#define H_LDAPPLUGIN

#include <BipCni.h>
#include <BipCci.h>

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */  
#include <BipSampPluginUtil.h>
#endif


#ifndef max                                   
#define max(x, y) (((x) > (y)) ? (x) : (y))   
#endif                                        
                                              
#ifndef min                                   
#define min(x,y) (((x)<(y)) ? (x) : (y))      
#endif                                        
                                              
#define MAX_ATTR_NAME_LEN     128
#define MAX_NODE_NAME_LEN     128
#define MAX_STRING_SIZE       256
#define MAX_TERMINAL_NAME_LEN 256
#define CNI_TYPE_INTEGER        1
#define CNI_TYPE_STRING         2


#define MAX_ATTRIBUTE_NAME_LEN     128
#define MAX_NODE_NAME_LEN          128
#define MAX_TERMINAL_NAME_LEN      256

#ifndef FALSE
#define FALSE	0==1
#endif
#ifndef TRUE
#define TRUE	1==1
#endif

#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */
/* ---------------------------------------------------------------- */
/*                     Internal constants                           */
/*                                                                  */
/* The interface expects some CciChar strings to be passed. These   */
/* have to be constructed from char strings using the supplied      */
/* utilities. The char constants are defined here along with the    */
/* static CciChar variables which will contain these constants      */
/* converted into CciChar format.                                   */
/*                                                                  */
/* ---------------------------------------------------------------- */
#define CONST_MQSERIES_INTEGRATOR_2       "MQSIv201"
const CciChar *constMQSeriesIntegrator2	= 0;

#define CONST_PLUGIN_NODE                 "LdapPlugInNode"
const CciChar *constPlugInNode            = 0;

#define CONST_PLUGIN_NODE_FACTORY         "LdapPlugInNodeFactory"
const CciChar *constPluginNodeFactory     = 0;

#define CONST_OUT                         "out"
const CciChar *constOut                   = 0;

#define CONST_FAILURE							"failure"
const CciChar *constFailure					= 0;

#define CONST_ENTRY                       "Entry"
const CciChar *constEntry                 = 0;

#define CONST_VALUE                       "Value"
const CciChar *constValue                 = 0;

#endif

typedef struct _nodeStringBuffer
{
  int length;
  int size;
  char* buf;
} NodeStringBuffer;


#if defined(__CCI_SOLARIS__) || defined(__CCI_HPUX__)|| defined(__CCI_LINUX__)/* 16/09/2001 */
#define CCI_CHECK_RC()                                                                        \
   if (rc != CCI_SUCCESS) {                                                                   \
     if (rc == CCI_EXCEPTION) cciRethrowLastException(0);                                     \
     else {                                                                                   \
       return;                                                                                \
     }                                                                                        \
   }
#else
#define CCI_CHECK_RC()                                                                        \
   if (rc != CCI_SUCCESS) {                                                                   \
     if (rc == CCI_EXCEPTION) cciRethrowLastException(0);                                     \
     else {                                                                                   \
       return;                                                                                \
     }                                                                                        \
   }
#endif

typedef struct attributeTblEntry {
   void*    next;                    /* Pointer to next entry */
   void*    valptr;                  /* Pointer to value */
   int      type;                    /* Value type */
   CciChar  name[MAX_ATTR_NAME_LEN]; /* Attribute name */
} ATTRIBUTE_TBL_ENTRY;


typedef struct terminalListEntry {
   void*        next;                        /* Pointer to next entry */
   CciTerminal* handle;                      /* Handle to terminal object */
   CciChar      name[MAX_TERMINAL_NAME_LEN]; /* Terminal name */
} TERMINAL_LIST_ENTRY;


typedef struct context {
   CciNode*             nodeObject;                  /* Handle for node object */
   ATTRIBUTE_TBL_ENTRY* attrListHead;                /* Head of linked list of attributes */
   ATTRIBUTE_TBL_ENTRY* attrListPrevious;            /* Previous entry in attribute list */
   TERMINAL_LIST_ENTRY* inputTerminalListHead;       /* Head of linked list of input terminal handles */
   TERMINAL_LIST_ENTRY* inputTerminalListPrevious;   /* Previous entry in input terminal list */
   TERMINAL_LIST_ENTRY* outputTerminalListHead;      /* Head of linked list of output terminal handles */
   TERMINAL_LIST_ENTRY* outputTerminalListPrevious;  /* Previous entry in output terminal list */
   CciChar              nodeName[MAX_NODE_NAME_LEN]; /* Node name */
} NODE_CONTEXT_ST;




/* Function Prototypes */

/* Node Utility Functions */
ATTRIBUTE_TBL_ENTRY *insertAttributeTableEntry
(
   NODE_CONTEXT_ST *context,
   CciChar    *nodeName, 
   CciChar    *attributeName,
   int         type
);


void *getInputTerminalHandle(
   NODE_CONTEXT_ST* context,
   CciChar*         terminalName
);


TERMINAL_LIST_ENTRY *insertInputTerminalListEntry
(
   NODE_CONTEXT_ST *context,
   CciChar *terminalName 
);

void *getOutputTerminalHandle(
   NODE_CONTEXT_ST* context,
   CciChar*         terminalName
);


TERMINAL_LIST_ENTRY *insertOutputTerminalListEntry
(
   NODE_CONTEXT_ST *context,
   CciChar *terminalName 
);



/* Node Implementation Functions */
void *createNodeContext( void    *factoryObject,
                         CciChar *nodeName,
                         void    *nodeObject );

int getAttributeName( CciContext* context,
                      int         index,
                      CciChar*    buffer,
                      int         bufsize );

int setAttribute( CciContext* context,
                  CciChar*    attrName,
                  CciChar*    attrValue );

int getAttribute( CciContext* context,
                  CciChar*    attrName,
                  CciChar*    buffer,
                  int         bufsize );

char *UnicodeToASCII(const CciChar *lStr);
CciChar *ASCIIToUnicode(const char *aStr);

char *StrUpper(char *string);


#endif
